---
title: column-fill
slug: Web/CSS/column-fill
tags:
  - CSS
  - CSS Multi-column Layout
  - CSS Property
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>column-fill</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property controls how an element's contents are balanced when broken into columns.</p>

<div>{{EmbedInteractiveExample("pages/css/column-fill.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
column-fill: auto;
column-fill: balance;
column-fill: balance-all;

/* Global values */
column-fill: inherit;
column-fill: initial;
column-fill: unset;
</pre>

<p>The <code>column-fill</code> property is specified as one of the keyword values listed below. The initial value is <code>balance</code> so the content will be balanced across the columns.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>Columns are filled sequentially. Content takes up only the room it needs, possibly resulting in some columns remaining empty.</dd>
 <dt><code>balance</code></dt>
 <dd>Content is equally divided between columns. In fragmented contexts, such as <a href="/en-US/docs/Web/CSS/Paged_Media">paged media</a>, only the last fragment is balanced. Therefore in paged media, only the last page would be balanced.</dd>
 <dt><code>balance-all</code></dt>
 <dd>Content is equally divided between columns. In fragmented contexts, such as <a href="/en-US/docs/Web/CSS/Paged_Media">paged media</a>, all fragments are balanced.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Example">Example</h2>

<h3 id="Balancing_column_content">Balancing column content</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p class="fill-auto"&gt;
  This paragraph fills columns one at a time. Since all of the text can fit in the first column, the others are empty.
&lt;/p&gt;

&lt;p class="fill-balance"&gt;
  This paragraph attempts to balance the amount of content in each column.
&lt;/p&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">p {
  height: 7em;
  background: #ff9;
  columns: 3;
  column-rule: 1px solid;
}

p.fill-auto {
  column-fill: auto;
}

p.fill-balance {
  column-fill: balance;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Balancing_column_content', 'auto', 320)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Multicol', '#cf', 'column-fill')}}</td>
   <td>{{Spec2('CSS3 Multicol')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.column-fill")}}</p>

<div class="notecard warning">
<p>Note that there are some interoperability issues and bugs with <code>column-fill</code> across browsers, due to unresolved issues in the specification.</p>

<p>In particular, when using <code>column-fill: auto</code> to fill columns sequentially, Chrome will only consult this property if the multicol container has a size in the block dimension (e.g., height in a horizontal writing mode). Firefox will always consult this property, therefore filling the first column with all of the content in cases where there is no size.</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/CSS/CSS_layout/Multiple-column_Layout">Multiple-column Layout</a></li>
 <li>{{CSSXref("column-count")}}</li>
 <li>{{CSSXref("column-width")}}</li>
</ul>
